$syj::guilimit = 5;					//maximum number of guis one server may make
$syj::guielementlimit = 15;				//maximum elements each gui may have
$syj::currentguis = 0;					//tracking how many guis have been made

function createdisposablegui(%name)
{
	if(strlen(%name) > 30)				//we dont want excessivily long gui names
	{
		syj_error($syj::error::gntl);
		return;
	}

	for(%a=0;%a<$syj::currentguis;%a++)
	{
		if($syj::guinames[%a] $= %name)				//keep gui names different
		{
			syj_error($syj::error::ivn);
			return;
		}
	}

	if($syj::currentguis < $syj::guilimit)				//make sure the gui limit is kept
	{
		$syj::gui[$syj::currentguis] = new GuiControl();
		$syj::gui[$syj::currentguis].setname("SYJ_" @ %name);	//make sure the name will not conflict
		$syj::guinames[$syj::currentguis] = %name;		//with any default/preexisting guis
		$syj::guielements[$syj::currentguis] = 0;
		$syj::currentguis++;
	}
	else	syj_error($syj::error::tmg);
}

function addguielement(%guiname,%type,%name,%parent)
{
	if(strpos(%guiname,";") != -1)
	{
		syj_error($syj::error::bt);
		return;
	}
	if(strpos(%type,";") != -1)
	{
		syj_error($syj::error::bt);		//these four blocks hopefully 'sterilize' code
		return;					//since ultimatly they will be passed though an eval function
	}	
	if(strpos(%name,";") != -1)
	{
		syj_error($syj::error::bt);
		return;
	}
	if(strpos(%parent,";") != -1)
	{
		syj_error($syj::error::bt);
		return;
	}

	%selg = -1;
	for(%a=0;%a<$syj::guilimit;%a++)
		if($syj::guinames[%a] $= %guiname)			//search for the gui by %guiname
			%selg = %a;
	if(%selg == -1)
	{  
		syj_error($syj::error::gnf);				//if not found, abort
		return;
	}

	%selp = -1;
	for(%a=0;%a<$syj::guielementlimit;%a++)
		if($syj::elementname[%selg,%a] $= %parent)		//search for the parent gui by %parent
			%selp = %a;

	if(%parent == -1)
		%selp = -1;

	if(strlen(%name) > 30)						//we dont want excessivily long gui names
	{
		syj_error($syj::error::gntl);
		return;
	}	
	
	if($syj::guielements[%selg] < $syj::guielementlimit)		//enforce element limit
	{
		if(getsubstr(%type,0,3) $= "Gui")
		{
			if(getsubstr(%type,strlen(%type)-4,4) $= "Ctrl")	//make sure only gui elements may be made
			{
				eval("$syj::element[%selg,$syj::guielements[%selg]] = new " @ %type @ "();");
				if(%selp != -1)
					$syj::element[%selg,%selp].add($syj::element[%selg,$syj::guielements[%selg]]);
				else
					$syj::gui[%selg].add($syj::element[%selg,$syj::guielements[%selg]]);
				$syj::element[%selg,$syj::guielements[%selg]].setname("SYJ_" @ %guiname @ %name);
				$syj::elementname[%selg,$syj::guielements[%selg]] = %name;
				if(%type $= "GuiWindowCtrl")						//for now, all things just close when you try to close them
					$syj::element[%selg,$syj::guielements[%selg]].closecommand = "canvas.popdialog(" @ $syj::gui[%selg] @ ");";
				$syj::guielements[%selg]++;
			}
			else syj_error($syj::error::bt);
		}
		else syj_error($syj::error::bt);
	}
	else 	syj_error($syj::error::tmg);
}

function addguiattribute(%guiname,%elementname,%attribute,%value)
{
	if(strpos(%guiname,";") != -1)
	{
		syj_error($syj::error::bt);
		return;
	}
	if(strpos(%elementname,";") != -1)
	{
		syj_error($syj::error::bt);		//these four blocks hopefully 'sterilize' code
		return;					//since ultimatly they will be passed though an eval function
	}	
	if(strpos(%attribute,";") != -1)
	{
		syj_error($syj::error::bt);
		return;
	}
	if(strpos(%value,";") != -1)
	{
		syj_error($syj::error::bt);
		return;
	}

	%selg = -1;
	for(%a=0;%a<$syj::guilimit;%a++)
		if($syj::guinames[%a] $= %guiname)			//search for the gui by %guiname
			%selg = %a;
	if(%selg == -1)
	{  
		syj_error($syj::error::gnf);				//if not found, abort
		return;
	}

	%selv = -1;
	for(%a=0;%a<$syj::guielementlimit;%a++)
		if($syj::elementname[%selg,%a] $= %elementname)		//search for element within gui
			%selv = %a;

	if(%selv == -1)
	{  
		syj_error($syj::error::gnf);				//if not found, abort
		return;
	}

	%element = $syj::elementname[%selg,%selv];

	if(strpos(%attribute,"command") != -1)
	{
		syj_error($syj::error::ati);			//make sure it is not something which can excucute code
		return;
	}

	if(%attribute $= "visible")
		eval("SYJ_" @ %guiname @ %element @ ".setvisible(" @ %value @ ");");
	if(%attribute $= "text")
		eval("SYJ_" @ %guiname @ %element @ ".settext(" @ %value @ ");");

	eval("SYJ_" @ %guiname @ %element @ "." @ %attribute @ "=\"" @ %value @ "\";");
}

function forceopendisposablegui(%guiname)
{
	%selg = -1;
	for(%a=0;%a<$syj::guilimit;%a++)
		if($syj::guinames[%a] $= %guiname)			//search for the gui by %guiname
			%selg = %a;
	if(%selg == -1)
	{  
		syj_error($syj::error::gnf);				//if not found, abort
		return;
	}

	%tg = $syj::gui[%selg];
	canvas.pushdialog(%tg);				//open
}

package syj_removeguis
{
	function disconnect(%a,%b,%c,%d,%e,%f)
	{
		Parent::disconnect(%a,%b,%c,%d,%e,%f);
		for(%a=0;%a<$syj::currentguis;%a++)
			if(isObject($syj::gui[%a]))
			{
				canvas.popdialog($syj::gui[%a]);	//just incase it was open
				$syj::gui[%a].delete();			//dispose of the disposable
			}
		$syj::currentguis = 0;					//reset our count
	}
};
activatepackage(syj_removeguis);

//Tunnels
//Yay
function clientcmdsyj_cdg(%a){createdisposablegui(%a);}
function clientcmdsyj_age(%a,%b,%c,%d){addguielement(%a,%b,%c,%d);}
function clientcmdsyj_aga(%a,%b,%c,%d){addguiattribute(%a,%b,%c,%d);}
function clientcmdsyj_fog(%a){forceopendisposablegui(%a);}


